{ :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  :: QuickReport 3.0 for Delphi 3 or newer                   ::
  ::                                                         ::
  :: Demo to print labels that go from left to right         ::
  ::                                                         ::
  :: Copyright (c) 1999 QuSoft AS                            ::
  :: All Rights Reserved                                     ::
  ::                                                         ::
  :: web: http://www.qusoft.no   fax: +47 22 41 74 91        ::
  ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }
unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Db, DBTables, quickrpt, DBCtrls, Mask, ExtCtrls, Grids, DBGrids;

type
  TfrmExprMain = class(TForm)
    tbCountry: TTable;
    btnPreview: TButton;
    dsCountry: TDataSource;
    DBNavigator1: TDBNavigator;
    DBEdit1: TDBEdit;
    qryCustomer: TQuery;
    dsCustomer: TDataSource;
    DBGrid1: TDBGrid;
    QryUpdate: TTimer;
    Memo1: TMemo;
    Label1: TLabel;
    Image2: TImage;
    Label2: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    procedure btnPreviewClick(Sender: TObject);
    procedure dsCountryDataChange(Sender: TObject; Field: TField);
    procedure QryUpdateTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure AddMyDataSets(rep: TQuickRep);

var
  frmExprMain: TfrmExprMain;

implementation

uses rpt1;

{$R *.DFM}

procedure TfrmExprMain.btnPreviewClick(Sender: TObject);
var
  frmrpt1: Tfrmrpt1;
begin
  frmrpt1 := Tfrmrpt1.Create(Application);
  frmrpt1.QuickRep1.Preview;
  frmrpt1.Free;
end;

procedure AddMyDataSets(rep: TQuickRep);
var I : integer;
  procedure AddForm(Form : TCustomForm);
  var j : integer;
  begin
    // Add each dataset to the report's list if it is not already
    // in the list
    with rep.AllDataSets do
      for j:=0 to Form.ComponentCount - 1 do
        if Form.Components[J] is TDataSet then
          if IndexOf(TDataSet(Form.Components[J])) = -1 then
            rep.AllDataSets.Add(TDataSet(Form.Components[J]));
  end;
begin
  for i := 0 to Screen.CustomFormCount - 1 do
    AddForm(Screen.CustomForms[I]);
end;

procedure TfrmExprMain.dsCountryDataChange(Sender: TObject; Field: TField);
begin
  QryUpdate.Enabled := false;
  QryUpdate.Enabled := true;
end;

procedure TfrmExprMain.QryUpdateTimer(Sender: TObject);
begin
  QryUpdate.Enabled := False;

  with qryCustomer do begin
    if Active then
      Close;

    Params[0].AsString := tbCountry.FieldByName('Name').AsString;

    Open;
  end;

end;

end.
